Red/System [
	Title:		"ZeroMQ request/reply client example"
	Author:		"Kaj de Vos"
	Rights:		"Copyright (c) 2011 Kaj de Vos. All rights reserved."
	License: {
		Redistribution and use in source and binary forms, with or without modification,
		are permitted provided that the following conditions are met:

		    * Redistributions of source code must retain the above copyright notice,
		      this list of conditions and the following disclaimer.
		    * Redistributions in binary form must reproduce the above copyright notice,
		      this list of conditions and the following disclaimer in the documentation
		      and/or other materials provided with the distribution.

		THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
		ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
		WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
		DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
		FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
		DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
		SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
		CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
		OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
		OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	}
	Needs:		%ZeroMQ-binding.reds
	Tabs:		4
]


#include %../ZeroMQ-binding.reds


; Examples

major: struct [value [integer!]]
minor: struct [value [integer!]]
patch: struct [value [integer!]]

version major minor patch
prin "0MQ version: "  ; prin major  prin "."  prin minor  prin "."  print patch


print error-message 0


; Hello World client/server

;data: struct [text [c-string!]]
;data: struct [string [pointer!]]

client: func [
	/local pool [handle!] socket [handle!] count [integer!] text [c-string!]  ; message [handle!]
][
	pool: new-pool 1
	; For 0MQ <= 2.0.6:
;	pool: new-pool 1 1 0

	print "Connecting to Hello World server..."

	socket: open pool request
	connect socket "tcp://localhost:5555"

	text: "Hello"

	count: 0

	until [
		count: count + 1

		prin "Sending request "  ; print count
		send socket text  1 + length? text  0

;		message: receive socket 0
		receive socket 0
;		prin "Received reply "  prin count  prin ": "  print message-data message
		prin "Received reply: "  print message-data message
		end-message message

		count = 10
	]
	close socket
	end-pool pool
]

client
